1000 :
1010 rem Sprite viewer
1020 rem pjwitte February 8th 2004
1030 rem V0.07 - see     history
1040 rem >>>   V0.08b - bsjr 15.04.05;
1050 rem >>>   show sprite at address if CMD$='Sprv@name$xxxxxxxx%n'
1060 rem >>>   id, title to use, sprite address, pal no
1070 rem >>>   V0.09a - bsjr 21.04.06;       add save as _pic
1080 :
1090 EXT_FN 'MN_SPRV','GET_SSPRA','GET_FSPRA'
1100 :
1110 REMark $$chan=4
1120 REMark $$stak=512
1130 REMark $$asmb=win1_Qpt_Cu_Per_spv_sprv_bin,0,10
1140 :
1150 DIM pr%(16)
1160 mxnl% =   13             : rem Max name length
1170 pal = 0                  : rem Default palette
1180 lisz% =   116            : rem Sprite loose       item size
1190 txw% = 19                : rem Info     text width
1200 sp_titletextbg%     = 517: rem Title text background
1210 sp_titlefg%         = 518: rem Title foreground
1220 sp_litemavabg%      = 520: rem Loose item available         background
1230 sp_litemavafg%      = 521: rem Loose item available         foreground
1240 sp_litemselbg%      = 522: rem Loose item selected background
1250 sp_litemselfg%      = 523: rem Loose item selected foreground
1260 sp_litemunabg%      = 524: rem Loose item unavailable background
1270 :
1280 c$ = CMD$
1290 cadr=0:   syspal=0: rem >>>8; chk       for adr, set title and pal (+ pal adr)
1300 if len(c$) then
1310  cadr=ChkSPRADR(c$,n$,pal)
1320  if cadr then c$='$': rem >>>8;         valid address
1330 end if
1340 :
1350 rem Un-rem these lines to develop under           SBasic
1360 if ver$   = 'HBA'   then
1370  if peek$(\\-4,     4) = 'SBAS' then
1380  lrespr'win1_Qpt_Cu_Per_spv_sprv_bin'
1390  if cadr=0 then     c$ = 'win1_QpP_Su_Qlb_S_infoh1_spr %0'
1400  JOB_NAME 'SprvAPM': cmpl%=0: rem >>>8
1410  end if
1420 end if
1430 :
1440 rem       Extract   pal
1450 if len(c$) = 0:     Erm -15
1460 p% = ' %' instr     c$
1470 if p% >   0 then
1480  if len(c$) > (p% + 1):       pal = c$(p% + 2     to)
1490  for i%   = p% to   1 step -1: if c$(i%) <>       ' ': exit i%
1500  c$ = c$(1 to i%)
1510 end if
1520 :
1530 if pal =4 and cadr then
1540  sp_jobownpal -1, syspal: rem >>>8; pal           from APM
1550 else
1560  sp_jobpal -1, pal
1570 end if
1580 :
1590 rem >>>   skip if   cadr
1600 if cadr=0
1610  ch = FOP_IN(c$): Erm ch
1620  ad = ALCHP(FLEN(#ch))
1630  CLOSE #ch
1640 :
1650  LBYTES   c$, ad
1660 end if
1670 :
1680 ch = FOPEN('con_0x0')
1690 outl #ch: rdpt #ch; 48
1700 flim #ch; xm%, ym%, xo%, yo%
1710 close #ch
1720 :
1730 rem >>>   skip if   cadr
1740 if cadr=0
1750  e% = LEN(c$) -     4
1760  FOR s%   = e% TO   1 STEP -1
1770   IF c$(s%) ='_': s% = s% + 1: EXIT s%
1780  END FOR s%
1790  n$ = c$(s% TO e%)
1800 else
1810  ad=cadr
1820 end if
1830 :
1840 mode% =   PEEK(ad)
1850 IF mode% = 0 then
1860  sspr% = peek(ad + 1): rem Flag: system           sprite
1870  rechp ad: rem release index
1880  ad = get_sspra(sspr%):       rem System sprite address
1890  mode% = peek(ad)
1900 else
1910  sspr% = -1
1920 end if
1930 :
1940 if mode% = 2 then LdHdSpr
1950 sx% = PEEK_W(ad     + 4)
1960 sy% = PEEK_W(ad     + 6)
1970 IF sx% > (xm% -     40): Erm -4
1980 IF sy% > (ym% -     40): Erm -4
1990 IF sx% < (lisz%     - 2): xs% = lisz%: ELSE       : xs% =   sx% + 2
2000 IF sy% < (lisz%     - 2): ys% = lisz%: ELSE       : ys% =   sy% + 2
2010 :
2020 if len(n$) <= mxnl% then
2030  n$ = fill$(' ', (mxnl%       - len(n$)) div 2) & n$
2040 else
2050  n$ = n$(1 to mxnl%)
2060 end if
2070 :
2080 ch = FOPEN('con_')
2090 msetup #ch; mn_sprv, -1, -1, xs% + 30, ys% + 30
2100 minob #ch; 3, 1, n$
2110 if mode% = 2 then
2120  mitem #ch; -3,     -2, hd
2130 else
2140  mitem #ch; -3,     -2, ad
2150 end if
2160 mdraw #ch
2170 :
2180 s% = 0:   Inispr
2190 sprd = 0
2200 REPeat dl
2210  k = mcall(#ch;     k, s%):   pval #ch; pr%
2220  sel on   k
2230   = -1:   rem Wmove (CF4)
2240   = -2:   rem ESC   (27)
2250      if   sprd then
2260       sprs #ch;     0
2270       sprd = 0
2280      else
2290       mclear #ch: clamp: close:         quit
2300      end if
2310   = -3:   rem avail/sel colr (tab)
2320      if   pr%(5) = 2 then
2330       s% = mstat%(#ch; k to -1)
2340      else
2350       s% = mstat%(#ch; k)
2360      end if
2370      spr = 0
2380   = -6:   rem Reset (CF2)
2390      s%   = mstat%(#ch; -3 to 0)
2400      s%   = 0: spr = 0: inf = 0
2410      Inispr
2420   = -7:   rem Palette (P)
2430      if   pr%(5)=2 then save2pic ad: next         dl: rem   >>>9
2440      pal = (mtext$(#ch;       k) + 1)   mod (4 +(syspal<>0))
2450      if   pal =4 then
2460       sp_jobownpal -1, syspal
2470      else
2480       sp_jobpal     -1, pal
2490      end if
2500      mdraw #ch
2510      mitem #ch;     k, 0, '' & pal
2520      s%   = 0
2530   = -5:   rem Down (D, next sprite definition)
2540      if   pr%(5) = 2 then
2550       if sprd =     0 then
2560        if sx% <= 64 and       sy% <= 64 then
2570           sprs #ch; spr: sprd = 1
2580           beep 2,   2
2590        else
2600           Beep 999, 999
2610        end if
2620       else
2630        sprs #ch; 0: sprd = 0
2640        beep 2, 2
2650       end if
2660      else
2670       if spr: NextSpr
2680      end if
2690      if   spr = 0: Inispr
2700      if   inf then
2710       Info
2720      else
2730       ShowSpr spr
2740      end if
2750      s%   = 0
2760   = -4:   rem Info (F1)
2770      if   inf then
2780       inf = 0
2790       ShowSpr spr
2800      else
2810       inf = 1
2820       if spr = 0 then
2830        Inispr
2840        if disp_type > 8       and peek(spr) >     0 then
2850           rep gdl
2860            rem Find first     available sprite for this mode
2870            if peek(spr) =     2: exit   gdl
2880            if peek_l(spr + 20) = 0: spr =         0: exit   gdl
2890            spr = spr + peek_l(spr       + 20) +   20
2900           end rep   gdl
2910           if spr = 0: Inispr
2920        end if
2930       end if
2940       Info
2950      end if
2960      s%   = 0
2970  end sel
2980 END REPeat dl
2990 :
3000 def proc Inispr
3010 rem Reset GLObal variables
3020 spr = ad: blk =     0: ofs = 0: lspr = 0: sprno% = 1
3030 end def   Inispr
3040 :
3050 def proc Info
3060 mwindow   #ch; -3: cls #ch: over #ch; 0
3070 wm_ink #ch; sp_titlefg%: wm_paper #ch; sp_titletextbg%:     cls #ch; 3
3080 mode% =   peek(spr)
3090 :
3100 if sspr% >= 0 and sprno% = 1 then
3110  Inf0
3120 else
3130  if mode% = 1 then
3140   rem Standard QL colour sprite
3150   Inf1
3160  else
3170   if mode% = 2 then
3180    rem GD2 colour sprite
3190    Inf2
3200   else
3210    print #ch; 'Not defined'
3220   end if
3230  end if
3240 end if
3250 end def   Info
3260 :
3270 def proc Inftxt(txt$)
3280 print #ch; Centre$(txt$)
3290 wm_ink #ch; sp_litemavafg%: wm_paper #ch; sp_litemavabg%: cls #ch; 2
3300 end def   Inftxt
3310 :
3320 def proc Inf0
3330 loc n%
3340 Inftxt 'System sprite no. ' & sspr%
3350 Infend
3360 end def   Inf0
3370 :
3380 def proc Inf1
3390 Inftxt 'QL-colour sprite'
3400 if peek(spr + 1) = 0
3410  Dis 'mode'! 4
3420 else
3430  Dis 'mode'! 8
3440 end if
3450 Infend
3460 end def   Inf1
3470 :
3480 def proc Infend
3490 Time
3500 Dis 'adapt'! hex$(peek(spr + 3), 8)
3510 Dis 'x-size'! peek_w(spr + 4)
3520 Dis 'y-size'! peek_w(spr + 6)
3530 Dis 'x-orig'! peek_w(spr + 8)
3540 Dis 'y-orig'! peek_w(spr + 10)
3550 print #ch: Dis 'Sprite no', sprno%
3560 end def   Infend
3570 :
3580 def proc Inf2
3590 loc cm%
3600 Inftxt 'GD2-colour sprite'
3610 cm% = peek(spr + 1)
3620 sel on cm%
3630  =  0: Dis '1 bit black&white',         cm%
3640  =  3: Dis '1 bit pal mapped', cm%
3650  =  4: Dis '2 bit fixed pal', cm%
3660  =  7: Dis '2 bit pal mapped', cm%
3670  =  8: Dis '4 bit fixed pal', cm%
3680  = 15: Dis '4 bit pal mapped', cm%
3690  = 16: Dis '8 bit fixed pal', cm%
3700  = 31: Dis '8 bit pal mapped', cm%
3710  = 32: Dis '16 bit QPC/QXL', cm%
3720  = 33: Dis '16 bit Q40', cm%
3730  = 64: Dis '32 bit RGB0', cm%
3740 end sel
3750 Time
3760 rem Sprite control:
3770 cm% = peek(spr + 3)
3780 if (cm%   && 3) >   0: Dis 'cache',     cm% && 3
3790 Dis 'sprite block', Tstb$(cm%, 4)
3800 Dis 'option block', Tstb$(cm%, 8)
3810 Dis 'alpha channel', Tstb$(cm%,         32)
3820 Dis 'pattern compr', Tstb$(cm%,         64)
3830 Dis 'mask compr', Tstb$(cm%, 128)
3840 Dis 'x/y-size'!     peek_w(spr + 4)     & '/' &   peek_w(spr + 6)
3850 Dis 'x/y-orig'!     peek_w(spr + 8)     & '/' &   peek_w(spr + 10)
3860 print #ch
3870 if blk then
3880  sel on   ofs
3890  = 0: Dis 'Avail', sprno%
3900  = 4: Dis 'Avail & Curr', sprno%
3910  = 8: Dis 'Sel', sprno%
3920  = 12: Dis 'Sel & Curr', sprno%
3930  = 16: Dis 'Unavail', sprno%
3940  end sel
3950 else
3960  Dis 'Sprite no', sprno%
3970 end if
3980 end def   Inf2
3990 :
4000 def proc Dis(l$, d$)
4010 print #ch; l$; to (txw%       - len(d$)); d$
4020 end def   Dis
4030 :
4040 def proc Time
4050 if peek(spr + 2) = 0 then
4060  Dis 'time', 'static'
4070 else
4080  Dis 'time', peek(spr +       2)
4090 end if
4100 end def   Time
4110 :
4120 def fn Tstb$(v%, b%)
4130 if v% && b%: ret 'Yes':       else: ret 'No'
4140 end def   Tstb$
4150 :
4160 def proc Save2pic(adr)
4170 rem >>>9 N:
4180 loc s2adr, x%, y%, xo%,       yo%, tmp$, t%
4190  rem >>> Isolate sprite
4200  mwindow #ch; -3: over #ch;0
4210  rem print #ch;'adr: ' &adr: pause #ch
4220  tmp$='ram2_Sprv2pic_pic': s2adr=0
4230  x% = mstat%(#ch; -3): rem Get current status
4240  sel on   x%
4250   = -1:   wm_paper #ch; sp_litemunabg%
4260   =  0:   wm_paper #ch; sp_litemavabg%
4270   =  1:   wm_paper #ch; sp_litemselbg%
4280  end sel
4290  :: rem   cls #ch: pause #ch: return
4300  rem >>>9; get coords of sprt
4310  x% = peek_w(adr + 4) +4
4320  y% = peek_w(adr + 6) +4
4330  xo% =2   + (xs% - x% ) div 2
4340  yo% =2   + (ys% - y% ) div 2
4350  print #ch;'> '     &x% &'x' &y% &'a' &xo% &'x' &yo%
4360  s2adr=wsain(#ch,x%,y%)
4370  wsasv #ch,s2adr,x%,y%,xo%,yo%,0,0
4380  s_wsa s2adr,tmp$
4390  print #ch;'> '; tmp$
4400  if s2adr then rechp s2adr
4410 end def   Sav2pic
4420 :
4430 def proc ShowSpr(adr)
4440 loc ladr, x%, y%, xo%, yo%
4450 rem Isolate and     display   sprite
4460 mwindow   #ch; -3: over #ch; 0
4470 x% = mstat%(#ch; -3): rem Get current status
4480 sel on x%
4490  = -1: wm_paper     #ch; sp_litemunabg%
4500  =  0: wm_paper     #ch; sp_litemavabg%
4510  =  1: wm_paper     #ch; sp_litemselbg%
4520 end sel
4530 cls #ch
4540 mode% =   PEEK(adr)
4550 IF sspr% >= 0 THEN
4560  rem Dont poke about in       systems   sprites!
4570  x% = (xs% - peek_w(adr       + 4) + 6) div 2
4580  y% = (ys% - peek_w(adr       + 6) + 6) div 2
4590  sprw #ch; x%, y%, adr
4600 else
4610  ladr =   peek_l(adr + 20): poke_l adr + 20, 0
4620  x% = (xs% - peek_w(adr       + 4) + 6) div 2
4630  y% = (ys% - peek_w(adr       + 6) + 6) div 2
4640  xo% = peek_w(adr + 8):       yo% = peek_w(adr + 10)
4650  poke_l   adr + 8, 0
4660  sprw #ch; x%, y%, adr
4670  poke_l   adr + 20, ladr
4680  poke_w   adr + 8, xo%: poke_w adr + 10, yo%
4690 end if
4700 end def   ShowSpr
4710 :
4720 def proc NextSpr
4730 rem Caller's spr, blk and ofs
4740 rem First do blocks, then chain         along
4750 if blk then
4760  NxtSpr
4770 else
4780  cm% = peek(spr     + 3)
4790  if (cm% && 4) <> 0 then
4800   blk =   peek_l(spr + 28) + spr + 28: rem blk ->           sprite block
4810   lspr = spr
4820   spr =   peek_l(blk) + blk
4830  else
4840   if peek_l(spr     + 20) =   0 then
4850    spr = 0: sprno% = 0
4860   else
4870    spr = peek_l(spr + 20) + spr         + 20
4880   end if
4890  end if
4900 end if
4910 sprno% = sprno%     + 1
4920 end def   NextSpr
4930 :
4940 def proc NxtSpr
4950 rem Recursive
4960 ofs = ofs + 4
4970 if ofs > 16 then
4980  blk = 0: ofs =     0: spr = lspr
4990  if lspr = 0: ret
5000  if peek_l(spr + 20) = 0 then
5010   spr =   0
5020  else
5030   spr =   peek_l(spr + 20) + spr + 20
5040  end if
5050 else
5060  if peek_l(blk + ofs) =       0: NxtSpr
5070  spr = peek_l(blk + ofs) + blk + ofs
5080 end if
5090 end def   NxtSpr
5100 :
5110 def fn Centre$(txt$)
5120 rem Centre text
5130 if len(txt$) < txw% then
5140  ret fill$(' ',     (txw% -   len(txt$)) div 2) & txt$
5150 else
5160  ret txt$(1 to txw%)
5170 end if
5180 end def   Centre$
5190 :
5200 def proc Erm(er)
5210 rem Not   finished
5220 if er >= 0: ret
5230 if peek$(\\-4, 4) <> 'SBAS': quit: rem Quit without error!
5240 end def   Erm
5250 :
5260 def proc LdSspr(adr)
5270 rem Load system     sprite into buffer
5280 sysspr = 1: rem     Flag system sprite
5290 rechp ad: rem Release index
5300 end def   LdSspr
5310 :
5320 def proc LdHdSpr
5330 rem EasyPtr cant handle       complex   sprites   yet
5340 rem So this inserts a QL sprite         in front to fool EP
5350 rem (and Wman1)     Wman2 knows about hi-def sprites and
5360 rem will display correctly. Wman1 will display a ?
5370 :
5380 hd = alchp(80)
5390 restore 5390
5400 for p =   hd to hd + 78 step 2: read w: poke_w p,           w
5410 poke_l hd + 20,     ad - hd   - 20
5420 end def   LdHdSpr
5430 :
5440 data 256,0     :rem dc.b  $1,$0,$0,$0
5450 data 5,7       :rem dc.w  $5,$7
5460 data 0,0       :rem dc.w  0,0
5470 data 0,12      :rem dc.l  q4p-*
5480 data 0,36      :rem dc.l  trans-*
5490 data 0,0       :rem dc.l  ???-*
5500 rem
5510 rem q4p
5520 data 28672,0   :rem dc.w  $7000,$0000
5530 data -30720,0  :rem dc.w  $8800,$0000
5540 data 2048,0    :rem dc.w  $0800,$0000
5550 data 4096,0    :rem dc.w  $1000,$0000
5560 data 8192,0    :rem dc.w  $2000,$0000
5570 data 0,0       :rem dc.w  $0000,$0000
5580 data 8192,0    :rem dc.w  $2000,$0000
5590 rem
5600 rem trans
5610 data 0,0       :rem dc.w  $0000,$0000
5620 data 0,0       :rem dc.w  $0000,$0000
5630 data 0,0       :rem dc.w  $0000,$0000
5640 data 0,0       :rem dc.w  $0000,$0000
5650 data 0,0       :rem dc.w  $0000,$0000
5660 data 0,0       :rem dc.w  $0000,$0000
5670 data 0,0       :rem dc.w  $0000,$0000
5680 :
5690 def fn ChkSPRADR (var$,nme$,pl)
5700  rem >>> var$='Sprv@name$xxxxxxxx%n'
5710  REM >>> name can be empty, %n can be left out or if $xxx.. is pal adr
5720  local po,v$,lv%,a$,ii:       nme$=''
5730   if var$(1 to 6) <>'Sprv@' then return 0: rem   >>> no id1
5740   lv%=len(var$): if lv%       <14 then return     0 : rem   >>> too   short
5750   :
5760   po='%' instr var$: v$=var$
5770   if po   then
5780    a$=var$(po +1 to)
5790    if a$(1) instr '0123' then pl=a$
5800    if a$(1)='$'     then
5810     if len(a$)=9 then syspal=HEX2ADR(a$): rem >>> $ & 8     chrs
5820     if syspal then pl=4: else pl=0
5830    end if
5840    v$=var$(1 to     po -1)                        : rem >>> trim palette
5850   end if
5860   :
5870   v$=v$(7 to): lv%=len(v$)              : rem >>> trim id
5880   po='$' instr v$: lv%=lv%-8
5890   if po   <1 or po <>lv% then return 0  : rem >>> no $ or 8 chrs
5900   if po   >1 then   nme$=v$(1 to po-1): else nme$='sprite'
5910   a$=v$(po to):     return HEX2ADR(a$)  : rem >>> $ & 8     chrs
5920 end def
5930 :
5940 def fn HEX2ADR (h$)
5950  for ii=2 to 9
5960   if not h$(ii)     instr '1234567890ABCDEF' then return 0:           rem >>>   not hex
5970   end for ii
5980   rem >>> so far so good
5990   return hex(h$(2 to))
6000 end def
